#ifndef __SIRZSET_H__
#define __SIRZSET_H__

//**********************************************************************
//* SirZSet Version 4.01 (C) SIR Pty Ltd 1989-1999                     *
//*                                                                    *
//* This software is provided as is, without any explicit or           *
//* implied warranties. Use it at your own risk.                       *
//**********************************************************************

//**********************************************************************
//* This header file contains prototypes for a set of Z-functions      *
//* known as "host" library in previous versions of SIR.               *
//*                                                                    *
//* This file is Microsoft Windows specific. This version implements   *
//* Z-functions as export symbols of sirdbms.dll and it uses __stdcall *
//* calling convention, but all arguments of Z-functions are pointers. *
//* Fortran's CHARACTER*(*) STRING arguments are pointers to Fortran   *
//* string descriptors (see FSTRDESC typedef).                         *
//*                                                                    *
//* If you used the previous version of "host" library, you need to    *
//* remove Watcom's pragma aux ... "^" from your code. Use sirdbms.lib *
//* import library to link your application.                           *
//*                                                                    *
//* Your application will use SIR's DLLs, so the SIR's home directory  *
//* must be included into your PATH (unless you place your executable  *
//* file into that directory).                                         *
//*                                                                    *
//* Z-functions are provided to support existing programs. We strongly *
//* encourage you to use SirAPI for new development.                   *
//*                                                                    *
//* The system is not reenterable, so you must not call any of these   *
//* functions before the previous call is completed.                   *
//**********************************************************************

typedef struct {
    char *data;
    int length;
} FSTRDESC;

#ifdef __cplusplus
extern "C" {
#endif

int __stdcall zafter (int *DUMMY);
int __stdcall zattr  (FSTRDESC *FNAM, FSTRDESC *FDSN, int *FDSNL);
int __stdcall zbegin (int *DUMMY);
int __stdcall zbltrc (void *DESC);
int __stdcall zcache (int *FNC, int *VAL);
int __stdcall zcall  (int *ZFUNC, int *TYPEFL, int *ENDFL, int *LBLNO, int *CODE1, int *CODE2);
int __stdcall zccnt  (int *A1, int *A2, int *A3);
int __stdcall zccntd (int *A1, int *A2, int *A3, FSTRDESC *DBNAME);
int __stdcall zcdel  (int *DUMMY);
int __stdcall zcexit (int *OSEED);
int __stdcall zcfind (int *OPT, int *LFLAG, int *DIRECT, int *BEGIN);
int __stdcall zcfrst (int *LFLAG);
int __stdcall zcgdmy (FSTRDESC *DBNAME);
int __stdcall zcis   (int *NEW, int *OLD);
int __stdcall zcisd  (int *NEW, int *OLD, FSTRDESC *DBNAME);
int __stdcall zclast (int *LFLAG);
int __stdcall zclear (int *USERNO);
int __stdcall zclock (int *LCK);
int __stdcall zcnext (int *LFLAG);
int __stdcall zcprev (int *LFLAG);
int __stdcall zcrdmy (int *DUMMY);
int __stdcall zcrest (int *LFLAG);
int __stdcall zcsam  (float *SAMPLE, int *SEED);
int __stdcall zcsamd (float *SAMPLE, int *SEED, FSTRDESC *DBNAME);
int __stdcall zcwrit (int *LFLAG);
int __stdcall zdesc  (void *DESC, int *RECTYP, FSTRDESC *VNAM, int *HLEVEL);
int __stdcall zdescb (void *DESC, int *DBN, int *RTY, int *VRN, int *SLV);
int __stdcall zdescd (void *DESC, FSTRDESC *DBNAME, int *RECTYP, FSTRDESC *VNAM, int *HLEVEL);
int __stdcall zdescm (void *DESC, int *DBN, int *RTY, int *VRN, int *SLV);
int __stdcall zdetal (int *DUMMY);
int __stdcall zdttky (FSTRDESC *DATEST, int *LENGTH, FSTRDESC *DATEMP);
int __stdcall zdttrc (FSTRDESC *STRDAT, int *LENG, FSTRDESC *DATMAP, void *DESC);
int __stdcall zdtxin (FSTRDESC *DATEST, int *ORDIN, FSTRDESC *DATEMP, int *LENGTH);
int __stdcall zdtxky (FSTRDESC *DATEST, int *ORDIN, int *LENGTH, FSTRDESC *DATEMP);
int __stdcall zdtxrc (FSTRDESC *STRDAT, int *ORDIN, int *LENG, FSTRDESC *DATMAP, void *DESC);
int __stdcall zend   (int *TSUSED);
int __stdcall zenddb (FSTRDESC *DBNAME);
int __stdcall zermsg (int *IIERR, FSTRDESC *BUFFER, int *BUFL, int *LOGFIL, FSTRDESC *RNAM);
int __stdcall zexit  (int *OSEED);
int __stdcall zfptky (float *FVALUE);
int __stdcall zfptrc (float *DATA, void *DESC);
int __stdcall zfpxky (float *FVALUE, int *ORDIN, int *LENGTH);
int __stdcall zfpxrc (void *DATA, int *ORDIN, int *LENGTH, void *DESC);
int __stdcall zfrom  (int *DUMMY);
int __stdcall zintky (int *IVALUE);
int __stdcall zintrc (int *DATA, void *DESC);
int __stdcall zinxdt (int *IDAYS, FSTRDESC *DATEST, int *ORDIN, int *LENGTH, FSTRDESC *DATEMP);
int __stdcall zinxky (void *IVALUE, int *ORDIN, int *LENGTH);
int __stdcall zinxrc (void *DATA, int *ORDIN, int *LENGTH, void *DESC);
int __stdcall zinxtm (int *ITIME, FSTRDESC *STRTIM, int *ORDIN, int *LENGTH, FSTRDESC *TIMMAP);
int __stdcall zlabel (void *DESC, FSTRDESC *CSTRNG, int *LENGTH);
int __stdcall zlabln (void *DESC, void *VALUE, FSTRDESC *CSTRNG, int *LENG);
int __stdcall zlabls (void *DESC, FSTRDESC *VALUE, int *LENGS1, FSTRDESC *CSTRNG, int *LENGS2);
int __stdcall zlckrt (FSTRDESC *DBNAME, int *RECTYP, int *LFLAG);
int __stdcall zlogin (FSTRDESC *MDSN, int *MLEN, FSTRDESC *SDSN, int *SLEN);
int __stdcall zmslab (void *DESC, int *VALUE, FSTRDESC *CSTRNG, int *LENG);
int __stdcall zmstrc (int *NUMB, void *DESC);
int __stdcall zncase (FSTRDESC *DBNAME);
int __stdcall znew   (int *DUMMY);
int __stdcall znor   (int *RECTYP);
int __stdcall znord  (FSTRDESC *DBNAME, int *RECTYP);
int __stdcall znrecs (FSTRDESC *DBNAME, int *RECTYP);
int __stdcall znsids (FSTRDESC *DBNAME, int *RECTYP);
int __stdcall znvars (FSTRDESC *DBNAME, int *RECTYP);
int __stdcall zopen  (FSTRDESC *DBN);
int __stdcall zopt   (int *OPT);
int __stdcall zordb  (FSTRDESC *DBNAME, FSTRDESC *DBPASS, FSTRDESC *HSPASS, FSTRDESC *RDPASS, FSTRDESC *WRPASS, int *UPD, FSTRDESC *PREFIX, int *PRELEN);
int __stdcall zrcnt  (int *RECTYP, int *A1, int *A2, int *A3);
int __stdcall zrcntd (int *RECTYP, int *A1, int *A2, int *A3, FSTRDESC *DBNAME);
int __stdcall zrcntl (int *RECTYP, int *A1, int *A2, int *A3, int *LVCASE);
int __stdcall zrctdt (void *DESC, FSTRDESC *STRDAT, int *LENG, FSTRDESC *DATMAP);
int __stdcall zrctfp (void *DESC, void *DATA);
int __stdcall zrctin (void *DESC, void *DATA);
int __stdcall zrctrc (void *DESC1, void *DESC2);
int __stdcall zrctst (void *DESC, FSTRDESC *CDATA, int *LENG);
int __stdcall zrcttm (void *DESC, FSTRDESC *STRTIM, int *LENG, FSTRDESC *TIMMAP);
int __stdcall zrcxdt (void *DESC, FSTRDESC *STRDAT, int *ORDIN, int *LENG, FSTRDESC *DATMAP);
int __stdcall zrcxfp (void *DESC, void *DATA, int *ORDIN, int *LENGTH);
int __stdcall zrcxin (void *DESC, void *DATA, int *ORDIN, int *LENGTH);
int __stdcall zrcxst (void *DESC, FSTRDESC *CDATA, int *ORDIN, int *LENG);
int __stdcall zrcxtm (void *DESC, FSTRDESC *STRTIM, int *ORDIN, int *LENG, FSTRDESC *TIMMAP);
int __stdcall zrdel  (int *DUMMY);
int __stdcall zrexit (int *OSEED);
int __stdcall zrfind (int *OPT, int *LFLAG, int *DIRECT, int *BEGIN1, int *BEGIN2);
int __stdcall zrfrst (int *LFLAG);
int __stdcall zrgdmd (int *RECTYP, FSTRDESC *DBNAME);
int __stdcall zrgdml (int *RECTYP, int *LVCASE);
int __stdcall zrgdmy (int *RECTYP);
int __stdcall zris   (int *RECTYP, int *NEW, int *OLD);
int __stdcall zrisd  (int *RECTYP, int *NEW, int *OLD, FSTRDESC *DBNAME);
int __stdcall zrisl  (int *RECTYP, int *NEW, int *OLD, int *LVCASE);
int __stdcall zrlast (int *LFLAG);
int __stdcall zrlock (int *LCK);
int __stdcall zrnamd (FSTRDESC *DBNAME, int *RECTYP, FSTRDESC *RNAME);
int __stdcall zrnext (int *LFLAG);
int __stdcall zrnum  (FSTRDESC *RNAM);
int __stdcall zrnumd (FSTRDESC *DBNAME, FSTRDESC *RNAM);
int __stdcall zrprev (int *LFLAG);
int __stdcall zrrdmy (int *DUMMY);
int __stdcall zrrest (int *LFLAG);
int __stdcall zrsam  (int *RECTYP, float *SAMPLE, int *SEED);
int __stdcall zrsamd (int *RECTYP, float *SAMPLE, int *SEED, FSTRDESC *DBNAME);
int __stdcall zrsaml (int *RECTYP, float *SAMPLE, int *SEED, int *LVCASE);
int __stdcall zrwrit (int *LFLAG);
int __stdcall zsdesc (FSTRDESC *DBNAME, int *RECTYP, int *SIDNUM, void *VDESC);
int __stdcall zseclv (FSTRDESC *DBNAME, int *RDLEV, int *WRLEV);
int __stdcall zsecur (FSTRDESC *DBNAME, FSTRDESC *RDP, FSTRDESC *WRP);
int __stdcall zstart (int *MAXUSR, int *TABTYP, int *TAB1, void *TAB2);
int __stdcall zsttky (FSTRDESC *CVALUE, int *LENG);
int __stdcall zsttrc (FSTRDESC *DATA, int *LENG, void *DESC);
int __stdcall zstxky (FSTRDESC *CVALUE, int *ORDIN, int *LENG);
int __stdcall zstxrc (FSTRDESC *DATA, int *ORDIN, int *LENG, void *DESC);
int __stdcall zthru  (int *DUMMY);
int __stdcall ztime  (int *ID, int *IT);
int __stdcall ztmtky (FSTRDESC *TIMEST, int *LENGTH, FSTRDESC *TIMEMP);
int __stdcall ztmtrc (FSTRDESC *STRTIM, int *LENG, FSTRDESC *TIMMAP, void *DESC);
int __stdcall ztmxin (FSTRDESC *TIMEST, int *ORDIN, FSTRDESC *TIMEMP, int *LENGTH);
int __stdcall ztmxky (FSTRDESC *TIMEST, int *ORDIN, int *LENGTH, FSTRDESC *TIMEMP);
int __stdcall ztmxrc (FSTRDESC *STRTIM, int *ORDIN, int *LENG, FSTRDESC *TIMMAP, void *DESC);
int __stdcall zuntil (int *DUMMY);
int __stdcall zuplev (FSTRDESC *DBNAME);
int __stdcall zuser  (void *NEWSTR);
int __stdcall zvarlb (void *DESC, FSTRDESC *CSTRNG, int *LENG);
int __stdcall zvers  (int *VERNUM, int *VERLEV, int *REVNUM, int *REVLEV);
int __stdcall zvname (void *DESC, FSTRDESC *VNAM);
int __stdcall zvtype (void *DESC, int *LENGTH);
int __stdcall zwith  (int *DUMMY);

#ifdef __cplusplus
}
#endif

#endif
